#include "setseg.h"


//  formato adotado para o display
/*
            6
         -------
        |       |
      5 |       | 4
        |   3   |
         -------
        |       |
      2 |       | 1
        |       |
         -------
            0
*/


void setseg::proc_counter(){

  int tmpCounter;
  sc_uint<4> tmp;
  sc_lv<7> tmpStatus;

  if(reset_ni.read()==false){
    counter.write(0);
    status.write("1110111");
    temp.write(0);
  }
  else{
    if(counter.read()==2){
      tmp=temp.read();
      tmp++;
      if(tmp==10) tmp=0;
      temp.write(tmp);
      switch(tmp){
        case 0: tmpStatus="1110111"; break; // 0, 1, 2, 4, 5, 6
        case 1: tmpStatus="0010010"; break; // 1,4
        case 2: tmpStatus="1011101"; break; // 0, 2, 3, 4, 6
        case 3: tmpStatus="1011011"; break; // 0, 1, 3, 4, 6
        case 4: tmpStatus="0111010"; break; // 1, 3, 4, 5
        case 5: tmpStatus="1101011"; break; // 0, 1, 3, 5, 6
        case 6: tmpStatus="1101111"; break; // 0, 1, 2, 3, 5, 6
        case 7: tmpStatus="1010010"; break; // 1, 4, 6
        case 8: tmpStatus="1111111"; break; // 0, 1, 2, 3, 4, 5, 6
        case 9: tmpStatus="1111011"; break; // 0, 1, 3, 4, 5, 6
      }
      status.write(tmpStatus);
      counter.write(0);
    }
    else{
      tmpCounter=counter.read();
      counter.write(tmpCounter+1);
    }
  }
}

void setseg::proc_setseg(){
  setseg_o.write(status.read());
}
